#! /usr/local/bin/perl

#######################################################
#BooCrossWordPazzleMaker,v1.05 / this program is free.#
# (C) BooBooClub 2001-2005                            #
#######################################################

#set data

$dat = './bcwp.dat';
$wcolor = '#00aa00';
$hcolor = '#8800ff';
$answer = '#ff0000';
$border = '#aaaaaa';



#set lib
require './jcode.pl';


#lock
&lock;


#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$name =~ tr/+/ /;
	$name =~ s/\cM\n//g;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ s/\,//g;
	$name =~ s/</&lt;/ig;
	$name =~ s/>/&gt;/ig;
	$name =~ s/\r\n|[\r\n]/<br>/ig;
	$value =~ tr/+/ /;
	$value =~ s/\cM\n//g;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\,//g;
	$value =~ s/</&lt;/ig;
	$value =~ s/>/&gt;/ig;
	$value =~ s/\r\n|[\r\n]/<br>/ig;
	&jcode'convert(*value,'sjis');
	$FORM{$name} = $value;
}



#branch

if($FORM{'set'}){
	&set;
}
elsif($FORM{'next'}){
	&next;
}
elsif($FORM{'back'}){
	&back;
}
elsif($FORM{'next2'}){
	&next2;
}
elsif($FORM{'make'}){
	&make;
}
elsif($FORM{'read'}){
	&read;
}



sub set{
	$wide = $FORM{'wide'};
	$high = $FORM{'high'};

	if($wide == 0 || $high == 0 || $wide eq '' || $high eq ''){
		&error;
	}

	print "Content-type: text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<title>Boo CrossWord Pazzle -MakingPage-</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="#ffffff">'."\n";
	print '<!--BooCrossWordPazzle_Produced by BooBooClub_http://www.booboo.ne.jp/-->';
	print '<center>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print 'Boo CrossWord Pazzle -MakingPage-<br>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print '<form method="POST" action="./bcwpm.cgi">'."\n";
	print '<input type="hidden" name="wide" value="'."$wide".'">'."\n";
	print '<input type="hidden" name="high" value="'."$high".'">'."\n";
	print '<table border="1" bordercolor="'."$border".'" cellspacing="0">'."\n";
	for($h = 0; $h <= $high; $h++){
		print '<tr>'."\n";
		for($w = 0; $w <= $wide; $w++){
			if($w == 0 && $h == 0){
				print '<td bgcolor="'."$border".'"><font color="'."$border".'"></font></td>'."\n";
			}
			elsif($h == 0){
				print '<td align="center"><font color="'."$wcolor".'">'."$w".'</td>'."\n";
			}
			elsif($w == 0){
				print '<td align="right"><font color="'."$hcolor".'">'."$h".'</td>'."\n";
			}
			else{
				$box = $w.'-'.$h;
				if($FORM{$box} ne ''){
					print '<td><input type="text" name="'."$w-$h".'" value="'."$FORM{$box}".'" size="2" maxlength="2"></td>'."\n";
				}
				else{
					print '<td><input type="text" name="'."$w-$h".'" size="2" maxlength="2"></td>'."\n";
				}
			}
		}
		print '</tr>'."\n";
	}
	print '</table>'."\n";
	print '<br>'."\n";
	print '<input type="submit" name="next" value="Next">'."\n";
	print '</form>'."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";

	unlink("$lockfile");
	exit 0;
}



sub next{

	$wide = $FORM{'wide'};
	$high = $FORM{'high'};

	for($h = 1; $h <= $high; $h++){
		$wline = $hline = $twline = $thline = '';
		for($w = 1; $w <= $wide; $w++){
			$wbox = $w.'-'.$h;
			$hbox = $h.'-'.$w;
			$wline .= "$FORM{$wbox}".',';
			$hline .= "$FORM{$hbox}".',';
			$twline .= "$w-$h:$FORM{$wbox}".',';
			$thline .= "$h-$w:$FORM{$hbox}".',';
		}
		push(@wline,$wline);
		push(@hline,$hline);
		push(@twline,$twline);
		push(@thline,$thline);
	}

	$twline = '<!--lmt-->'.join('<!--lmt-->',@twline);
	$twline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$twline =~ s/,\d+?-\d+?://g;
	$twline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$twline =~ s/,//g;
	@twline = split(/<!--lmt-->/,$twline);

	$thline = '<!--lmt-->'.join('<!--lmt-->',@thline);
	$thline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$thline =~ s/,\d+?-\d+?://g;
	$thline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$thline =~ s/,//g;
	@thline = split(/<!--lmt-->/,$thline);

	print "Content-type: text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<title>Boo CrossWord Pazzle -MakingPage-</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="#ffffff">'."\n";
	print '<center>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print 'Boo CrossWord Pazzle -MakingPage-<br>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print '<form method="POST" action="./bcwpm.cgi">'."\n";
	print '<input type="hidden" name="wide" value="'."$wide".'">'."\n";
	print '<input type="hidden" name="high" value="'."$high".'">'."\n";
	print '<table border="1" bordercolor="'."$border".'" cellspacing="0">'."\n";
	for($h = 0; $h <= $high; $h++){
		print '<tr>'."\n";
		for($w = 0; $w <= $wide; $w++){
			if($w == 0 && $h == 0){
				print '<td bgcolor="'."$border".'"><font color="'."$border".'"></font></td>'."\n";
			}
			elsif($h == 0){
				print '<td align="center"><font color="'."$wcolor".'">'."$w".'</td>'."\n";
			}
			elsif($w == 0){
				print '<td align="center"><font color="'."$hcolor".'">'."$h".'</td>'."\n";
			}
			else{
				$box = $w.'-'.$h;
				if($FORM{$box} eq '' || $FORM{$box} !~ /[^\s]/){
					$FORM{$box} = '<font color="'."$border".'"></font>';
					print '<td bgcolor="'."$border".'">'.$FORM{$box}.'<input type=hidden name="'."$w-$h".'" value="'."$FORM{$w-$h}".'"></td>'."\n";
				}
				else{
					print '<td>'.$FORM{$box}.'<input type=hidden name="'."$w-$h".'" value="'."$FORM{$box}".'"></td>'."\n";
				}
			}
		}
		print '</tr>'."\n";
	}
	print '</table>'."\n";
	print '<br>'."\n";
	print '<input type="submit" name="set" value="Back">'."\n";
	print ' @@ ';
	print '<input type="submit" name="next2" value="Next">'."\n";
	print '<br><br>'."\n";
	print '<center>'."\n";
	print '<table width=600 border=1 bordercolor="'."$border".'"><tr><td width=300>'."\n";
	print '<center>R̃JM쐬</center>'."\n";
	print '</td><td width=300>'."\n";
	print '<center>^ẽJM쐬</center>'."\n";
	print '</td></tr><tr><td valign=top>'."\n";
	print '<table>'."\n";
	print '<tr><td><font size=2>폜</font></td><td><font size=2></font></td><td><font size=2>JM</font></td></tr>'."\n";
	foreach $line(@twline){
		if($line eq '' && $line !~ /[^\s]/){
			next;
		}
		@line = split(/:/,$line);
		$word = 'w:'.$line[0];
		$delword = 'dw:'.$line[0];
		if($FORM{$delword} eq 'del'){
			$checked = ' checked';
		}
		else{
			$checked = '';
		}
		if($FORM{$word} ne ''){
			$wvalue = ' value="'."$FORM{$word}".'"';
		}
		else{
			$wvalue = '';
		}
		$line =~ s/(\d+?)-(\d+?):(.+)/<font color="$hcolor">$2<\/font>-<font color="$wcolor">$1<\/font>:<font color="$answer">$3<\/font>/;
		print '<tr><td><input type=checkbox name="dw:'."$line[0]".'" value="del"'."$checked".'></td><td><font size=2>'.$line.'</font></td><td><font size=2><input type=text size=20 name="'."w:$line[0]".'"'."$wvalue".'></font></td></tr>'."\n";
	}
	print '</table>'."\n";
	print '</td><td valign=top>'."\n";
	print '<table>'."\n";
	print '<tr><td><font size=2>폜</font></td><td><font size=2></font></td><td><font size=2>JM</font></td></tr>'."\n";
	foreach $line(@thline){
		if($line eq '' && $line !~ /[^\s]/){
			next;
		}
		@line = split(/:/,$line);
		$word = 'h:'.$line[0];
		$delword = 'dh:'.$line[0];
		if($FORM{$delword} eq 'del'){
			$checked = ' checked';
		}
		else{
			$checked = '';
		}
		if($FORM{$word} ne ''){
			$wvalue = ' value="'."$FORM{$word}".'"';
		}
		else{
			$wvalue = '';
		}
		$line =~ s/(\d+?)-(\d+?):(.+)/<font color="$hcolor">$2<\/font>-<font color="$wcolor">$1<\/font>:<font color="$answer">$3<\/font>/;
		print '<tr><td><input type=checkbox name="dh:'."$line[0]".'" value="del"'."$checked".'></td><td><font size=2>'.$line.'</font></td><td><font size=2><input type=text size=20 name="'."h:$line[0]".'"'."$wvalue".'></font></td></tr>'."\n";
	}
	print '</table>'."\n";
	print '</td></tr></table>'."\n";
	print '<br>'."\n";
	print '<input type="submit" name="set" value="Back">'."\n";
	print ' @@ ';
	print '<input type="submit" name="next2" value="Next">'."\n";
	print '</center>'."\n";
	print '</form>'."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";

	unlink("$lockfile");
	exit 0;
}



sub next2{

	$wide = $FORM{'wide'};
	$high = $FORM{'high'};

	for($h = 1; $h <= $high; $h++){
		$wline = $hline = $twline = $thline = '';
		for($w = 1; $w <= $wide; $w++){
			$wbox = $w.'-'.$h;
			$hbox = $h.'-'.$w;
			$wline .= "$FORM{$wbox}".',';
			$hline .= "$FORM{$hbox}".',';
			$twline .= "$w-$h:$FORM{$wbox}".',';
			$thline .= "$h-$w:$FORM{$hbox}".',';
		}
		push(@wline,$wline);
		push(@hline,$hline);
		push(@twline,$twline);
		push(@thline,$thline);
	}

	$twline = '<!--lmt-->'.join('<!--lmt-->',@twline);
	$twline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$twline =~ s/,\d+?-\d+?://g;
	$twline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$twline =~ s/,//g;
	@twline = split(/<!--lmt-->/,$twline);

	$thline = '<!--lmt-->'.join('<!--lmt-->',@thline);
	$thline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$thline =~ s/,\d+?-\d+?://g;
	$thline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$thline =~ s/,//g;
	@thline = split(/<!--lmt-->/,$thline);


	print "Content-type: text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<title>Boo CrossWord Pazzle -MakingPage-</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="#ffffff">'."\n";
	print '<center>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print 'Boo CrossWord Pazzle -MakingPage-<br>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print '<form method="POST" action="./bcwpm.cgi">'."\n";
	print '<input type="hidden" name="wide" value="'."$wide".'">'."\n";
	print '<input type="hidden" name="high" value="'."$high".'">'."\n";
	print '<table border="1" bordercolor="'."$border".'" cellspacing="0">'."\n";
	for($h = 0; $h <= $high; $h++){
		print '<tr>'."\n";
		for($w = 0; $w <= $wide; $w++){
			if($w == 0 && $h == 0){
				print '<td bgcolor="'."$border".'"><font color="'."$border".'"></font></td>'."\n";
			}
			elsif($h == 0){
				print '<td align="center"><font color="'."$wcolor".'">'."$w".'</td>'."\n";
			}
			elsif($w == 0){
				print '<td align="center"><font color="'."$hcolor".'">'."$h".'</td>'."\n";
			}
			else{
				$box = $w.'-'.$h;
				if($FORM{$box} eq '' || $FORM{$box} !~ /[^\s]/){
					$FORM{$box} = '<font color="'."$border".'"></font>';
					print '<td bgcolor="'."$border".'">'.$FORM{$box}.'<input type=hidden name="'."$w-$h".'" value="'."$FORM{$w-$h}".'"></td>'."\n";
				}
				else{
					print '<td>'.$FORM{$box}.'<input type=hidden name="'."$w-$h".'" value="'."$FORM{$box}".'"></td>'."\n";
				}
			}
		}
		print '</tr>'."\n";
	}
	print '</table>'."\n";
	print '<br>'."\n";
	print '<input type="submit" name="next" value="Back">'."\n";
	print ' @@ ';
	print '<input type="submit" name="make" value="Make">'."\n";
	print '<br><br>'."\n";
	print '<center>'."\n";
	print '<table width=600 border=1 bordercolor="'."$border".'"><tr><td width=300>'."\n";
	print '<center>R̃JM</center>'."\n";
	print '</td><td width=300>'."\n";
	print '<center>^ẽJM</center>'."\n";
	print '</td></tr><tr><td valign=top>'."\n";
	print '<table>'."\n";
	print '<tr><td><font size=2></font></td><td><font size=2></font></td><td><font size=2>JM</font></td></tr>'."\n";
	foreach $line(@twline){
		if($line eq '' && $line !~ /[^\s]/){
			next;
		}
		@line = split(/:/,$line);
		$word = 'w:'.$line[0];
		$delword = 'dw:'.$line[0];
		if($FORM{'next2'} eq ''){
			$word =~ s/(\d+?)-(\d+?)/$2-$1/;
			$delword =~ s/(\d+?)-(\d+?)/$2-$1/;
		}
		if($FORM{$delword} ne 'del' && $FORM{$word} ne '' && $FORM{$word} =~ /[^\s]/){
			$line =~ s/(\d+?)-(\d+?):(.+)/<font color="$hcolor">$2<\/font>-<font color="$wcolor">$1<\/font>:<font color="$answer">$3<\/font>/;
			print '<tr><td></td><td valign="top"><nobr><font size=2>'.$line.'</font></nobr></td><td><font size=2>'.$FORM{$word}.'</font></td></tr>'."\n";
			print '<input type=hidden name="'."w:$line[0]".'" value="'."$FORM{$word}".'">'."\n";
		}
		if($FORM{$delword} eq 'del'){
			print '<input type=hidden name="'."$delword".'" value="del">'."\n";
		}
	}
	print '</table>'."\n";
	print '</td><td valign=top>'."\n";
	print '<table>'."\n";
	print '<tr><td><font size=2></font></td><td><font size=2></font></td><td><font size=2>JM</font></td></tr>'."\n";


	foreach $line(@thline){
		if($line eq '' && $line !~ /[^\s]/){
			next;
		}
		@line = split(/:/,$line);
		$word = 'h:'.$line[0];
		$delword = 'dh:'.$line[0];
		if($FORM{'next2'} eq ''){
			$word =~ s/(\d+?)-(\d+?)/$2-$1/;
			$delword =~ s/(\d+?)-(\d+?)/$2-$1/;
		}
		if($FORM{$delword} ne 'del' && $FORM{$word} ne '' && $FORM{$word} =~ /[^\s]/){
			$line =~ s/(\d+?)-(\d+?):(.+)/<font color="$hcolor">$2<\/font>-<font color="$wcolor">$1<\/font>:<font color="$answer">$3<\/font>/;
			print '<tr><td></td><td valign="top"><nobr><font size=2>'.$line.'</font></nobr></td><td><font size=2>'.$FORM{$word}.'</font></td></tr>'."\n";
			print '<input type=hidden name="'."h:$line[0]".'" value="'."$FORM{$word}".'">'."\n";
		}
		if($FORM{$delword} eq 'del'){
			print '<input type=hidden name="'."$delword".'" value="del">'."\n";
		}
	}
	print '</table>'."\n";
	print '</td></tr></table>'."\n";
	print '<br>'."\n";
	print '<input type="submit" name="next" value="Back">'."\n";
	print ' @@ ';
	print '<input type="submit" name="make" value="Make">'."\n";
	print '</center>'."\n";
	print '</form>'."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";

	unlink("$lockfile");
	exit 0;

}



sub make{

	$wide = $FORM{'wide'};
	$high = $FORM{'high'};

	for($h = 1; $h <= $high; $h++){
		$wline = $hline = $twline = $thline = '';
		for($w = 1; $w <= $wide; $w++){
			$wbox = $w.'-'.$h;
			$hbox = $h.'-'.$w;
			$wline .= "$FORM{$wbox}".',';
			$hline .= "$FORM{$hbox}".',';
			$twline .= "$w-$h:$FORM{$wbox}".',';
			$thline .= "$w-$h:$FORM{$hbox}".',';
		}
		push(@wline,$wline);
		push(@hline,$hline);
		push(@twline,$twline);
		push(@thline,$thline);
	}

	$twline = '<!--lmt-->'.join('<!--lmt-->',@twline);
	$twline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$twline =~ s/,\d+?-\d+?://g;
	$twline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$twline =~ s/,//g;
	@twline = split(/<!--lmt-->/,$twline);

	$thline = '<!--lmt-->'.join('<!--lmt-->',@thline);
	$thline =~ s/\d+?-\d+?:,/<!--lmt-->/g;
	$thline =~ s/,\d+?-\d+?://g;
	$thline =~ s/(<!--lmt-->)+/<!--lmt-->/g;
	$thline =~ s/,//g;
	@thline = split(/<!--lmt-->/,$thline);

	$wspace = '@';

	map{
		$_ =~ s/^,/$wspace,/g;
		$_ =~ s/,,/,$wspace,/g;
		$_ =~ s/,,/,$wspace,/g;
	}@wline;
	$wline = join("\n",@wline);

	$key = 'w:';
	map{
		$_ =~ s/(\d+?)-(\d+?)(:).*/$1-$2$3$FORM{$key.$1.'-'.$2}/g;
	}@twline;

	$key = 'h:';
	map{
		$_ =~ s/(\d+?)-(\d+?)(:).*/$1-$2$3$FORM{$key.$2.'-'.$1}/g;
	}@thline;

	$twline = join("\n",@twline)."\n";
	$twline =~ s/\d+?-\d+?:\s*\n//g;
	$twline =~ s/^(\s+|\n+)//g;
	$twline =~ s/\n+$//;
	$thline = join("\n",@thline)."\n";
	$thline =~ s/\d+?-\d+?:\s*\n//g;
	$thline =~ s/^(\s+|\n+)//g;
	$thline =~ s/\n+$//;

	$data = 'size='.$wide.'-'.$high."\n\n";
	$data .= 'data='."\n".$wline."\n\n";
	$data .= 'wkey='."\n".$twline."\n\n";
	$data .= 'hkey='."\n".$thline."\n\n";

	open (DAT,">$dat");
	print DAT $data;
	close (DAT);

	print "Content-type: text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<title>Boo CrossWord Pazzle -MakingPage-</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="#ffffff">'."\n";
	print '<center>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print 'Boo CrossWord Pazzle -MakingPage-<br>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print 'pYf[^̍쐬܂B'."\n";
	print '<br>'."\n";
	print '<br>'."\n";
	print '<a href="./maker.html">쐬ʃgbvɖ߂</a><br>'."\n";
	print '<br>'."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";

	unlink("$lockfile");
	exit 0;
}



sub read{

	open (DAT,"$dat");
	@dat = <DAT>;
	close (DAT);

	$dat = join('',@dat);
	@dat = split(/\n\n/,$dat);

	foreach $dat(@dat){
		if($dat =~ /size=/){
			@size = split(/=/,$dat);
			($FORM{'wide'},$FORM{'high'}) = split(/-/,$size[1]);
		}
		if($dat =~ /data=/){
			$dat =~ s/data=.*?\n//;
			@data = split(/\n/,$dat);
			map{$_ =~ s/,$//;}@data;
			$h = 1;
			foreach $data(@data){
				@edata = split(/,/,$data);
				$w = 1;
				foreach $edata(@edata){
					if($edata ne '@' && $edata !~ /[\s]/ && $edata ne ''){
						$box = $w.'-'.$h;
						$FORM{$box} = $edata;
					}
					$w++;
				}
				$h++;
			}
		}
		if($dat =~ /wkey=/){
			$dat =~ s/wkey=.*?\n//;
			@data = split(/\n/,$dat);
			foreach $data(@data){
				@edata = split(/:/,$data);
				foreach $edata(@edata){
					$key = 'w:'.$edata[0];
					$FORM{$key} = $edata[1];
				}
			}
		}
		if($dat =~ /hkey=/){
			$dat =~ s/hkey=.*?\n//;
			@data = split(/\n/,$dat);
			foreach $data(@data){
				@edata = split(/:/,$data);
				foreach $edata(@edata){
					$key = 'h:'.$edata[0];
					$FORM{$key} = $edata[1];
				}
			}
		}
	}
	&next2;
}



sub lock{
	$lockfile = './lock/lockfile';
	$retry = 1;
	until (symlink("$dat", "$lockfile")){
		if (++$retry >= 30){
			&lockerror;
			exit 0;
		}
		sleep(1);
	}
}



sub lockerror{
	print "Content-type: text/html\n\n";
	print "<html><head><title>Busy!</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<br><h2>݃T[oGĂ܂B</h2><br><br>\n";
	print "܂΂炭čēxsĂB\n";
	print "<br></body></html>\n";
	unlink("$lockfile");
	exit 0;
}



sub error{
	print "Content-type: text/html\n\n";
	print "<html><head><title>Error!</title></head>\n";
	print "<body bgcolor=\"\#ffffff\">\n";
	print "<br><h2>Error!</h2><br><br>\n";
	print "c̃TCYwɌ肪܂B\n";
	print "<br></body></html>\n";
	unlink("$lockfile");
	exit 0;
}

